//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

public class Alerte: JSONDecodable, JSONEncodable, PrettyPrintable {

    public enum EtatCourant: String {
        case ok = "OK"
        case warning = "WARNING"
        case critical = "CRITICAL"

        public static let cases: [EtatCourant] = [
          .ok,
          .warning,
          .critical,
        ]
    }

    public enum TypeAlerte: String {
        case cambriolage = "CAMBRIOLAGE"
        case incendie = "INCENDIE"
        case detresse = "DETRESSE"

        public static let cases: [TypeAlerte] = [
          .cambriolage,
          .incendie,
          .detresse,
        ]
    }

    public var dateCreated: Date?

    public var etatCourant: EtatCourant?

    public var evenements: [Evenement]?

    public var foyerEmetteur: Foyer?

    public var foyerImpacte: Foyer?

    public var id: String?

    public var typeAlerte: TypeAlerte?

    public init(dateCreated: Date? = nil, etatCourant: EtatCourant? = nil, evenements: [Evenement]? = nil, foyerEmetteur: Foyer? = nil, foyerImpacte: Foyer? = nil, id: String? = nil, typeAlerte: TypeAlerte? = nil) {
        self.dateCreated = dateCreated
        self.etatCourant = etatCourant
        self.evenements = evenements
        self.foyerEmetteur = foyerEmetteur
        self.foyerImpacte = foyerImpacte
        self.id = id
        self.typeAlerte = typeAlerte
    }

    public required init(jsonDictionary: JSONDictionary) throws {
        dateCreated = jsonDictionary.json(atKeyPath: "dateCreated")
        etatCourant = jsonDictionary.json(atKeyPath: "etatCourant")
        evenements = jsonDictionary.json(atKeyPath: "evenements")
        foyerEmetteur = jsonDictionary.json(atKeyPath: "foyerEmetteur")
        foyerImpacte = jsonDictionary.json(atKeyPath: "foyerImpacte")
        id = jsonDictionary.json(atKeyPath: "id")
        typeAlerte = jsonDictionary.json(atKeyPath: "typeAlerte")
    }

    public func encode() -> JSONDictionary {
        var dictionary: JSONDictionary = [:]
        if let dateCreated = dateCreated?.encode() {
            dictionary["dateCreated"] = dateCreated
        }
        if let etatCourant = etatCourant?.encode() {
            dictionary["etatCourant"] = etatCourant
        }
        if let evenements = evenements?.encode() {
            dictionary["evenements"] = evenements
        }
        if let foyerEmetteur = foyerEmetteur?.encode() {
            dictionary["foyerEmetteur"] = foyerEmetteur
        }
        if let foyerImpacte = foyerImpacte?.encode() {
            dictionary["foyerImpacte"] = foyerImpacte
        }
        if let id = id {
            dictionary["id"] = id
        }
        if let typeAlerte = typeAlerte?.encode() {
            dictionary["typeAlerte"] = typeAlerte
        }
        return dictionary
    }

    /// pretty prints all properties including nested models
    public var prettyPrinted: String {
        return "\(Swift.type(of: self)):\n\(encode().recursivePrint(indentIndex: 1))"
    }
}
